/**
 * Copyright (C), 2015-2018, XXX有限公司
 * FileName: SignManageClient
 * Author:   phone
 * Date:     2018/4/9 16:59
 * Description: 签到-管理端
 * History:
 * <author>          <time>          <version>          <desc>
 * 作者姓名           修改时间           版本号              描述
 */
package com.yizhi.sign.application.feign;

import com.yizhi.sign.application.vo.domain.TrSign;
import com.yizhi.sign.application.vo.SignIdVO;
import com.yizhi.sign.application.vo.SignQrcodeVO;
import com.yizhi.sign.application.vo.SignVO;
import io.swagger.annotations.ApiOperation;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.List;

/**
 * 〈一句话功能简述〉<br> 
 * 〈签到-管理端〉
 *
 * @author phone
 * @create 2018/4/9
 * @since 1.0.0
 */
@FeignClient(name = "sign", contextId = "SignManageClient")
public interface SignManageClient {

	/**
	 * 新建签到信息
	 * @param signVO
	 * @return
	 */
    @PostMapping(value = "/remote/manage/sign/insert")
    public Long insert(@RequestBody SignVO signVO);

    /**
     * 获取签到信息
     * @param signIdVO
     * @return
     */
    @PostMapping(value = "/remote/manage/sign/view")
    public SignVO getSign(@RequestBody SignIdVO signIdVO);

    /**
     * 修改签到信息
     * @param signVO
     * @return
     */
    @PostMapping("/remote/manage/sign/update")
    public boolean update(@RequestBody SignVO signVO);

    /**
     * 删除签到信息
     * @param signIdVO
     * @return
     */
    @PostMapping("/remote/manage/sign/delete")
    public boolean deleteSignByProjectId(@RequestBody SignIdVO signIdVO);
    
    /**
	 * 获取生成的二维码Url
	 * @param signIdVO
	 * @return
	 */
    @PostMapping("/remote/manage/sign/qrcode/get")
    List<SignQrcodeVO> qrcode(@RequestBody SignIdVO signIdVO);

    @ApiOperation("根据签到id获取签到")
    @GetMapping("/remote/manage/sign/one/get")
    TrSign getSign(
            @RequestParam(name = "signId" )Long signId
    );
    @ApiOperation("根据签到时间段id获取签到")
    @GetMapping("/remote/manage/sign/time/get")
    TrSign getSignByTime(@RequestParam(name = "signTimeId" )Long signId);
}