/**
 * Copyright (C), 2015-2018, XXX有限公司
 * FileName: SignRecordClient
 * Author:   phone
 * Date:     2018/4/4 17:16
 * Description: 签到记录接口
 * History:
 * <author>          <time>          <version>          <desc>
 * 作者姓名           修改时间           版本号              描述
 */
package com.yizhi.sign.application.feign;

import com.yizhi.sign.application.vo.domain.TrSignRecord;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.List;

/**
 * 〈一句话功能简述〉<br>
 * 〈签到记录接口〉
 *
 * @author fanchunhui
 * @create 2018/4/4
 * @since 1.0.0
 */
@FeignClient(name = "sign", contextId = "SignRecordApiClient")
public interface SignRecordApiClient {

	/**
	 * 我的签到总数量
	 * @return
	 */
    @GetMapping("/remote/api/sign/record/count")
    Integer selectSignRecordCountByAccountId(@RequestParam("accountId") Long accountId);

	/**
	 * 获取签到完成数量( PC 端  学习统计签到 完成数量)
	 * @param trainingProjectId 培训项目ID
	 * @return
	 */
	@GetMapping("/remote/api/sign/record/pc/finishedCount")
	public Integer selectCountByTrainingProjectId(@RequestParam("trainingProjectId") Long trainingProjectId,@RequestParam("accountId")Long accountId);

	/**
	 *签到记录导出
	 * @param trainingProjectId
	 * @return
	 */
	@GetMapping("/remote/api/sign/record/export")
	public String exportSignRecord(@RequestParam(name = "trainingProjectId") Long trainingProjectId);

    @PostMapping("/remote/api/sign/record/insert")
    public boolean insertSignRecordList(@RequestBody List<TrSignRecord> signRecordList);
}
