package com.yizhi.sign.application.vo;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * Created by phone on 2018/3/8.
 */
@Data
@Api(tags = "SignTimeVO", description = "签到时间段VO，一个 sign 对应多个 sign_time")
public class SignTimeVO {

    @ApiModelProperty(value = "主键id（为空新增，不为空修改）")
    private Long id;

    @ApiModelProperty(value = "有效签到时间区间（日期）左值，格式：2018-05-17")
    private String startTime;
    
    @ApiModelProperty(value = "有效签到时间区间（小时）左值")
    private String startHour;
    
    @ApiModelProperty(value = "有效签到时间区间（分钟）左值")
    private String startMinute;
    

    @ApiModelProperty(value = "有效签到时间区间（日期）右值，格式：2018-05-17")
    private String endTime;
    
    @ApiModelProperty(value = "有效签到时间区间（小时）右值")
    private String endHour;
    
    @ApiModelProperty(value = "有效签到时间区间（分钟）右值")
    private String endMinute;
    
    @ApiModelProperty(value = "签到地点")
    private String address;
    
    @ApiModelProperty(value = "签到范围")
    private String range;

    @ApiModelProperty(value = "签到积分")
    private Integer point;
    
    @ApiModelProperty(value = "经度")
    private Double longitude;
    
    @ApiModelProperty(value = "纬度")
    private Double latitude;
}
