package com.yizhi.sign.application.vo.domain;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.FieldFill;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 * 签到主体表，入口在培训项目
 * </p>
 *
 * @author fanchunhui123
 * @since 2018-03-07
 */
@Data
@Api(tags = "TrSign", description = "签到主体表，入口在培训项目")
@TableName("tr_sign")
public class TrSign extends Model<TrSign> {

	private static final long serialVersionUID = 1L;

	@ApiModelProperty(value = "主键id")
	private Long id;

	@ApiModelProperty(value = "培训项目id")
	@TableField("training_project_id")
	private Long trainingProjectId;

	@ApiModelProperty(value = "签到名称")
	private String name;

	@ApiModelProperty(value = "0：生成一张，1：按时间段生成多张")
	private Integer type;

	@ApiModelProperty(value = "是否消息提醒（分钟），0不提醒")
	@TableField("remind_time")
	private Integer remindTime;

	@ApiModelProperty(value = "是否开启补签（0：否，1：是），默认否")
	@TableField("enable_retroactive")
	private Integer enableRetroactive;

	@ApiModelProperty(value = "是否开启邮件提醒（0：否，1：是），默认否。")
	@TableField("enable_remind_mail")
	private Integer enableRemindMail;

	@ApiModelProperty(value = "是否开启短信提醒（0：否，1：是），默认否。")
	@TableField("enable_remind_note")
	private Integer enableRemindNote;

	@ApiModelProperty(value = "是否开启app推送签到提醒，默认0")
	@TableField("enable_remind_app")
	private String enableRemindApp;

	@ApiModelProperty(value = "邮件模板")
	@TableField("mail_remind_template_id")
	private Long mailRemindTemplateId;

	@ApiModelProperty(value = "app消息推送模板")
	@TableField("app_remind_template_id")
	private Long appRemindTemplateId;

	@ApiModelProperty(value = "提醒内容")
	@TableField("remind_content")
	private String remindContent;

	@ApiModelProperty(value = "企业id")
	@TableField("company_id")
	private Long companyId;

	@ApiModelProperty(value = "站点id")
	@TableField("site_id")
	private Long siteId;

	@TableField("org_id")
	private Long orgId;

	@ApiModelProperty(value = "创建者id")
	@TableField(value = "create_by_id", fill = FieldFill.INSERT)
	private Long createById;

	@ApiModelProperty(value = "创建者名称")
	@TableField(value = "create_by_name", fill = FieldFill.INSERT)
	private String createByName;

	@ApiModelProperty(value = "创建时间")
	@TableField(value = "create_time", fill = FieldFill.INSERT)
	private Date createTime;

	@ApiModelProperty(value = "更新者id")
	@TableField(value = "update_by_id", fill = FieldFill.INSERT)
	private Long updateById;

	@ApiModelProperty(value = "修改者名称")
	@TableField(value = "update_by_name", fill = FieldFill.INSERT)
	private String updateByName;

	@ApiModelProperty(value = "修改时间")
	@TableField(value = "update_time", fill = FieldFill.INSERT)
	private Date updateTime;

	@ApiModelProperty(value = "是否删除：0.未删除 1.已删除")
	private Integer state;

	@ApiModelProperty(value = "可见范围")
	@TableField(exist = false)
	private Integer visibleRange;

	@ApiModelProperty("培训项目名称")
	@TableField(exist = false)
	private String trainningProjectName;

	@ApiModelProperty("培训项目创建时间")
	@TableField(exist = false)
	private Date projectCreateTime;

	@ApiModelProperty("签到时间段id")
	@TableField(exist = false)
	private Long signTimeId;

	@ApiModelProperty("某个签到的开始时间")
	@TableField(exist = false)
	private Date signStartDate;

	@ApiModelProperty("某个签到的结束时间")
	@TableField(exist = false)
	private Date signEndDate;

	@ApiModelProperty(value = "是否开启定位（0：否，1：是），默认否")
	@TableField("enable_position")
		private Integer enablePosition;
	
	@ApiModelProperty(value = "签到地点")
	@TableField("address")
		private String address;

	@ApiModelProperty(value = "签到范围")
	@TableField("range")
		private String range;
	@Override
	protected Serializable pkVal() {
		return this.id;
	}

}
