package com.yizhi.sign.application.vo.domain;

import java.util.Date;

import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.FieldFill;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

@Data
@Api(tags = "TrSignAccount", description = "小程序签到绑定关系表")
@TableName("tr_sign_account")
public class TrSignAccount {

	@ApiModelProperty(value = "主键id")
	private Long id;
	
	@ApiModelProperty(value = "用户id")
	@TableField(value = "account_id")
	private Long accountId;
	
	@ApiModelProperty(value = "小程序openId")
	@TableField(value = "open_id")
	private String openId;
	
	@ApiModelProperty(value = "是否解绑（0：否，1：是） 默认0")
	private Integer deleted;
	
	@ApiModelProperty(value = "签到邀请码")
	private String code;
	
	@ApiModelProperty(value = "创建者id")
	@TableField(value = "create_by_id", fill = FieldFill.INSERT)
	private Long createById;

	@ApiModelProperty(value = "姓名")
	@TableField(value = "full_name", fill = FieldFill.INSERT)
	private String fullName;
	
@ApiModelProperty(value = "创建者名称")
	@TableField(value = "create_by_name", fill = FieldFill.INSERT)
	private String createByName;

@ApiModelProperty(value = "创建时间")
	@TableField(value = "create_time", fill = FieldFill.INSERT)
	private Date createTime;

@ApiModelProperty(value = "更新者id")
	@TableField(value = "update_by_id", fill = FieldFill.INSERT)
	private Long updateById;

@ApiModelProperty(value = "修改者名称")
	@TableField(value = "update_by_name", fill = FieldFill.INSERT)
	private String updateByName;

@ApiModelProperty(value = "修改时间")
	@TableField(value = "update_time", fill = FieldFill.INSERT)
	private Date updateTime;
}
