package com.yizhi.sign.application.vo.domain;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableName;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 * 签到记录表
 * </p>
 *
 * @author fanchunhui123
 * @since 2018-03-07
 */
@Data
@Api(tags = "TrSignRecord", description = "签到记录表")
@TableName("tr_sign_record")
public class TrSignRecord extends Model<TrSignRecord> {

	private static final long serialVersionUID = 1L;

	@ApiModelProperty(value = "主键id")
	private Long id;

	@ApiModelProperty(value = "签到id")
	@TableField("sign_id")
	private Long signId;

	@ApiModelProperty(value = "培训项目id")
	@TableField("training_project_id")
	private Long trainingProjectId;

	@ApiModelProperty(value = "账号id")
	@TableField("account_id")
	private Long accountId;

	@ApiModelProperty(value = "签到时间")
	@TableField("sign_time")
	private Date signTime;

	@ApiModelProperty(value = "签到状态：0：正常签到，1：补签。默认0。")
	@TableField("sign_status")
	private Integer signStatus;

	@ApiModelProperty(value = "签到类型：0：平台签到，1：自定义项目。默认0。")
	@TableField("type")
	private Integer type;
	
	@ApiModelProperty(value = "创建时间")
	@TableField("create_time")
	private Date createTime;
	
	@ApiModelProperty(value = "签到地点")
	@TableField("address")
		private String address;
	@Override
	protected Serializable pkVal() {
		return this.id;
	}

}
