package com.yizhi.application.controller.remote;

import com.baomidou.mybatisplus.plugins.Page;
import com.yizhi.application.domain.StatisticsSign;
import com.yizhi.application.domain.StatisticsSignLearn;
import com.yizhi.application.domain.TrSign;
import com.yizhi.application.domain.TrSignTime;
import com.yizhi.application.mapper.StatisticsSignMapper;
import com.yizhi.application.orm.util.DomainConverter;
import com.yizhi.application.service.SignTimeService;
import com.yizhi.application.service.StatisticsSignService;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.Date;
import java.util.List;

@RestController
@RequestMapping("/remote/statisticsSign")
public class RemoteStatisticsSignController {

//    @Autowired
//    private StatisticsSignRun statisticsSignRun;

    @Autowired
    private StatisticsSignService statisticsSignService;

    @Autowired
    private SignTimeService signTimeService;

    @Autowired
    private StatisticsSignMapper statisticsSignMapper;

    @Autowired
    DomainConverter domainConverter;

//    @GetMapping("/asynchronous/load/data")
//    public Response<String> asynchronousSign(@RequestParam("startDate") String startDate, @RequestParam("endDate") String endDate) {
//        Map<String, Object> map = new HashMap<String, Object>();
//        map.put("startDate", startDate);
//        map.put("endDate", endDate);
//        statisticsSignRun.execute(map, true);
//        return Response.ok();
//    }

    @ApiOperation(value = "各项目的签到统计", notes = "各项目的签到统计")
    @GetMapping("/group")
    public Page<com.yizhi.sign.application.vo.domain.StatisticsSign> signPage(@RequestParam(name = "projectId", required = false) Long projectId,
                                                                              @RequestParam(name = "kwd", required = false) String kwd,
                                                                              @RequestParam(name = "startDate", required = false) String startDate,
                                                                              @RequestParam(name = "endDate", required = false) String endDate,
                                                                              @RequestParam(name = "signCompanyId", required = false) Long signCompanyId,
                                                                              @RequestParam(name = "signOrgIds", required = false) List<Long> signOrgIds,
                                                                              @RequestParam(name = "signSiteId", required = false) Long signSiteId,
                                                                              @RequestParam(name = "pageNo", required = false) Integer pageNo,
                                                                              @RequestParam(name = "pageSize", required = false) Integer pageSize) {
        return statisticsSignService.statisticsSignPage(projectId, kwd, startDate, endDate, signCompanyId, signOrgIds, signSiteId, pageNo, pageSize);
    }

    @ApiOperation(value = "某个项目的签到统计", notes = "某个项目的签到统计")
    @GetMapping("/group/view")
    public Page<com.yizhi.sign.application.vo.domain.StatisticsSign> signView(
            @RequestParam(name = "id", required = true) Long id,
            @RequestParam(name = "projectId", required = true) Long projectId,
            @RequestParam(name = "startDate", required = false) String startDate,
            @RequestParam(name = "endDate", required = false) String endDate,
            @RequestParam(name = "orgNameOrCode", required = false) String orgNameOrCode,
            @RequestParam(name = "accountName", required = false) String accountName,
            @RequestParam(name = "pageNo", required = false) Integer pageNo,
            @RequestParam(name = "pageSize", required = false) Integer pageSize) {
        Page<StatisticsSign> statisticsSignPage = statisticsSignService.statisticsSignView(id, projectId, startDate, endDate, orgNameOrCode, accountName, pageNo, pageSize);
        Page<com.yizhi.sign.application.vo.domain.StatisticsSign> page = new Page<>(pageNo,pageSize);
        BeanUtils.copyProperties(statisticsSignPage,page);
        return page;
    }

    @ApiOperation(value = "图形报表", notes = "图形报表")
    @GetMapping("/chart/group")
    public List<com.yizhi.sign.application.vo.domain.StatisticsSign> chartGroup(@RequestParam(name = "trainningProjectId", required = false) Long trainningProjectId,
                                                                                @RequestParam(name = "startDate", required = false) String startDate,
                                                                                @RequestParam(name = "endDate", required = false) String endDate,
                                                                                @RequestParam(name = "signCompanyId", required = false) Long signCompanyId,
                                                                                @RequestParam(name = "signOrgIds", required = false) List<Long> signOrgIds,
                                                                                @RequestParam(name = "signSiteId", required = false) Long signSiteId) {
        List<StatisticsSign> statisticsSigns = statisticsSignService.chartGroup(trainningProjectId, startDate, endDate, signCompanyId, signOrgIds, signSiteId);
        return domainConverter.toDOList(statisticsSigns, com.yizhi.sign.application.vo.domain.StatisticsSign.class);
    }

    @ApiOperation(value = "各项目的签到统计个数", notes = "各项目的签到统计个数")
    @GetMapping("/group/count")
    public Integer signPageCount(@RequestParam(name = "projectId", required = false) Long projectId,
                                 @RequestParam(name = "startDate", required = false) String startDate,
                                 @RequestParam(name = "endDate", required = false) String endDate,
                                 @RequestParam(name = "signCompanyId", required = false) Long signCompanyId,
                                 @RequestParam(name = "signOrgIds", required = false) List<Long> signOrgIds,
                                 @RequestParam(name = "signSiteId", required = false) Long signSiteId) {
        return statisticsSignService.statisticsSignPageCount(projectId, startDate, endDate, signCompanyId, signOrgIds, signSiteId);
    }

    @ApiOperation(value = "各项目的签到统计列表", notes = "各项目的签到统计")
    @GetMapping("/group/list")
    public List<com.yizhi.sign.application.vo.domain.StatisticsSign> signPageList(@RequestParam(name = "projectId", required = false) Long projectId,
                                             @RequestParam(name = "startDate", required = false) String startDate,
                                             @RequestParam(name = "endDate", required = false) String endDate,
                                             @RequestParam(name = "signCompanyId", required = false) Long signCompanyId,
                                             @RequestParam(name = "signOrgIds", required = false) List<Long> signOrgIds,
                                             @RequestParam(name = "signSiteId", required = false) Long signSiteId,
                                             @RequestParam(name = "pageNo", required = false) Integer pageNo,
                                             @RequestParam(name = "pageSize", required = false) Integer pageSize) {
        List<StatisticsSign> statisticsSigns = statisticsSignService.statisticsSignList(projectId, startDate, endDate, signCompanyId, signOrgIds, signSiteId, pageNo, pageSize);
        return domainConverter.toDOList(statisticsSigns, com.yizhi.sign.application.vo.domain.StatisticsSign.class);
    }

    @ApiOperation(value = "某个项目的签到统计个数", notes = "某个项目的签到统计个数")
    @GetMapping("/group/view/count")
    public Integer signViewCount(
            @RequestParam(name = "id", required = true) Long id,
            @RequestParam(name = "projectId", required = true) Long projectId,
            @RequestParam(name = "startDate", required = false) String startDate,
            @RequestParam(name = "endDate", required = false) String endDate,
            @RequestParam(name = "orgNameOrCode", required = false) String orgNameOrCode,
            @RequestParam(name = "accountName", required = false) String accountName) {
        return statisticsSignService.statisticsSignViewCount(id, projectId, startDate, endDate, orgNameOrCode, accountName);
    }

    @ApiOperation(value = "某个项目的签到统计个数列表", notes = "某个项目的签到统计个数列表")
    @GetMapping("/group/view/list")
    public List<com.yizhi.sign.application.vo.domain.StatisticsSign> signViewList(
            @RequestParam(name = "id", required = true) Long id,
            @RequestParam(name = "projectId", required = true) Long projectId,
            @RequestParam(name = "startDate", required = false) String startDate,
            @RequestParam(name = "endDate", required = false) String endDate,
            @RequestParam(name = "orgNameOrCode", required = false) String orgNameOrCode,
            @RequestParam(name = "accountName", required = false) String accountName,
            @RequestParam(name = "pageNo", required = false) Integer pageNo,
            @RequestParam(name = "pageSize", required = false) Integer pageSize) {
        List<StatisticsSign> statisticsSigns = statisticsSignService.statisticsSignViewList(id, projectId, startDate, endDate, orgNameOrCode, accountName, pageNo, pageSize);
        return domainConverter.toDOList(statisticsSigns,com.yizhi.sign.application.vo.domain.StatisticsSign.class);
    }

    @ApiOperation(value = "获取签到时间段", notes = "获取签到时间段")
    @GetMapping("/group/getSignTime")
    public com.yizhi.sign.application.vo.domain.TrSignTime getSignTime(@RequestParam("getSignTime") Long signTimeId) {
        TrSignTime trSignTime = signTimeService.selectById(signTimeId);
        com.yizhi.sign.application.vo.domain.TrSignTime trSignTime1 = new com.yizhi.sign.application.vo.domain.TrSignTime();
        BeanUtils.copyProperties(trSignTime,trSignTime1);
        return trSignTime1;
    }

    @GetMapping("/group/selectRecordMinTime")
    Date selectRecordMinTime() {
        return statisticsSignMapper.selectRecordMinTime();
    }

    @GetMapping("/group/getAllResearchs")
    List<com.yizhi.sign.application.vo.domain.TrSign> getAllResearchs(@RequestParam("startDate") String startDate, @RequestParam("endDate") String endDate) {
        List<TrSign> allResearchs = statisticsSignMapper.getAllResearchs(startDate, endDate);
        return domainConverter.toDOList(allResearchs,com.yizhi.sign.application.vo.domain.TrSign.class);
    }

    @GetMapping("/group/getRecords")
    List<com.yizhi.sign.application.vo.domain.StatisticsSignLearn> getRecords(@RequestParam("signTimeId") Long signTimeId, @RequestParam("startDate") String startDate, @RequestParam("endDate") String endDate) {
        List<StatisticsSignLearn> records = statisticsSignMapper.getRecords(signTimeId, startDate, endDate);
        return domainConverter.toDOList(records,com.yizhi.sign.application.vo.domain.StatisticsSignLearn.class);
    }
}
