package com.yizhi.application.service;

import com.baomidou.mybatisplus.plugins.Page;
import com.baomidou.mybatisplus.service.IService;
import com.yizhi.application.domain.TrSign;
import com.yizhi.sign.application.vo.*;
import com.yizhi.sign.application.vo.domain.SignRecordVO;

import java.util.List;

/**
 * <p>
 * 签到主体表，入口在培训项目 服务类
 * </p>
 *
 * @author fanchunhui123
 * @since 2018-03-07
 */
public interface SignService extends IService<TrSign> {

    boolean insertSignAndSignTimeAndSignRemind(SignVO signVO);

    boolean updateSignAndSignTimeAndSignRemind(SignVO signVO);
    
	/**   
	 *查询当前项目id对应的所有的签到时间列表
	* @Function: SignService.java
	* @Description: 
	*
	* @param:
	* @return：
	* @throws：
	*
	* @author: xingliang
	* @date: 2018年3月8日 上午11:08:13 
	*
	* 2018年3月8日     xingliang      
	*/
	List<SignQrcodeVO> querySignTime(Long trainingProjectId);

	/**   
	 * 学员签到
	* @Function: SignService.java
	* @Description: 
	*
	* @param:
	* @return：
	* @throws：
	*
	* @author: xingliang
	* @date: 2018年3月8日 下午2:35:27 
	*
	* 2018年3月8日     xingliang      
	*/
	String sign(Long accountId, String trainingProjectId, String signTimeId,Integer type);

	/**   
	 * 根据学员id信息,获取学员签到列表
	* @Function: SignService.java
	* @Description: 
	*
	* @param:
	* @return：
	* @throws：
	*
	* @author: xingliang
	* @date: 2018年3月9日 下午3:35:12 
	*
	* 2018年3月9日     xingliang      
	*/
	List<SignRecordVO> signRecordList(Long accountId);
	
	/**
	 * 获取签到信息
	 * @param trainingProjectId 培训项目ID
	 * @return 签到对象
	 */
	SignVO querySign(Long trainingProjectId);
	
	/**
	 * 获取我的签到
	 * @param accountId 学员ID
	 * @param month 月份为空查询所有
	 * @param pageIndex 页码
	 * @param pageSize 页数
	 * @return
	 */
	Page<TrSignRecordVo> selectSignRecordListByAccountIdAndMonth(Long accountId, String year, String month, int pageNo, int pageSize);

	boolean deleteSignByProjectId(SignIdVO signIdVO);

	TrSign selectByTimeId(Long signTimeId);

	Integer getSignTimeCount(SignVO signVO);



	/**********************************************************  PC 端  ******************************************************/

	/**
	 * 获取签到总数量( PC 端   培训项目中培训统计的签到总数)
	 * @param trainingProjectId
	 * @return
	 */
	Integer getPcSignTimeCount(Long trainingProjectId);
	
	ApiSignTimeVO getSignTimeDeatil(Long accountId, String code, Long trainingProjectId);
}
